<?php

class FilterMapping
{
    public function formatSieveScript( $rules )
    {
	$require_fileinto = $require_flag = $require_reject = $require_vacation = $require_body = $startswith = $endswith = false;

	$script_rules = $script_header = "";

	foreach( $rules as $name => $data )
	{
	    if( $data['enabled'] )
		continue;

	    $criteria = $data['criteria'];
	    $action   = $data['actions'];
	    $data['isExact'] ? $script_match = 'if allof (' : $script_match = 'if anyof (';

	    for ($j=0; $j<count($criteria); $j++)
	    {					
		switch($criteria[$j]['field']) {
		    case 'To':    /* Adicionar o TO e Cc também?! */
		    case 'CC':
			    $criteria[$j]['field'] = "[\"To\", \"TO\", \"Cc\", \"CC\"]"; 
			    $script_criteria .= "address :";
			    break;
		    case 'size':	
			    $criteria[$j]['field'] = '';
			    $script_criteria .= "size :";
			    break;
		    case 'subject':
			    $criteria[$j]['field'] = "\"" . $criteria[$j]['field'] . "\"";
			    $criteria[$j]['value'] = "[\"" . imap_8bit($criteria[$j]['value']) . "\", \"" . base64_encode($criteria[$j]['value']) . "\"]";
			    $script_criteria .= "header :";
			    break;
		    case 'body':
			    $criteria[$j]['field'] = '';
			    $criteria[$j]['value'] = "\"" . $criteria[$j]['value'] . "\"";
			    $script_criteria .= "body :";
			    $require_body = true;
			    break;
		    default:
			    $criteria[$j]['field'] = "\"" . $criteria[$j]['field'] . "\"";
			    $script_criteria .= "header :";
			    break;
		}
		
		switch ($criteria[$j]['operator']) {
		    case '>':
			    $criteria[$j]['operator'] = "over";
			    break;
		    case '<':
			    $criteria[$j]['operator'] = "under";
			    break;
		    case '=':
			    $criteria[$j]['operator'] = "is";
			    break;
		    case '*':
			    $criteria[$j]['operator'] = "contains";
			    break;						
		    case '^':
			    $criteria[$j]['operator'] = "matches";
			    $criteria[$j]['value'] = "[\"" . $criteria[$j]['value'] . "*\"]";
			    $startswith = true;
			    break;
		    case '$':
			    $criteria[$j]['operator'] = "matches";
			    $criteria[$j]['value'] = "[\"*" . $criteria[$j]['value'] . "*\"]";
			    $endswith = true;
			    break;
		}
		// if temporário, por favor! :D	
		if ($criteria[$j]['field'] == "" || $criteria[$j]['field'] == "\"subject\"" || $startswith || $endswith)
		{
		    $script_criteria .= $criteria[$j]['operator'] . " " . $criteria[$j]['field'] . " " . $criteria[$j]['value'] . ", "; 
		    $startswith = $endswith = false;
		}
		else
		    $script_criteria .= $criteria[$j]['operator'] . " " . $criteria[$j]['field'] . " \"" . $criteria[$j]['value'] . "\", ";
	    }
	    $script_criteria = substr($script_criteria,0,-2);
	    $script_criteria .= ")";
	    $script_action = " {\r\n ";
	    for ($k=0; $k<count($action); $k++)
	    {
		    switch ($action[$k]['type']) {
			    case 'redirect':
				    break;
			    case 'reject':
				    $require_reject = true;
				    break;
			    case 'fileinto':
				    $require_fileinto = true;
				    break;
			    case 'vacation':
				    $require_vacation = true;
				    break;
			    case 'setflag':
				    $require_flag = true;
				    break;
			    case 'discard':
				    break;
		    }
		    $script_action .= $action[$k]['type'] . " \"" . $action[$k]['parameter'] . "\";\r\n ";
	    }

	    $script_action .= "}";

	    $script_rules .= $script_match . $script_criteria . $script_action . "\r\n";
	}

	// if temporário meu caro amigo
	if($require_reject || $require_fileinto || $require_vacation || $require_body || $require_flag)
	{
		$script_header .= "require [";
		$require_reject ? $script_header .= "\"reject\", " : ""; 
		$require_fileinto ? $script_header .= "\"fileinto\", " : ""; 
		$require_vacation? $script_header .= "\"vacation\", " : "";  
		$require_flag ? $script_header .= "\"imapflags\", " : "";  
		$require_body ? $script_header .= "\"body\", " : "";  /* tem que instalar o plugin no SIEVE */
		$script_header = substr($script_header,0,-2);
		$script_header .= "];\r\n";
	}

	$json_data = json_encode($rules);
	
	$script_begin = "#Filtro gerado por Expresso Livre versão 2.4 power\r\n\r\n";

	$content = $script_begin . $script_header . $script_rules . "\r\n\r\n#PseudoScript#" . "\r\n#" . $json_data;

	return( $content );
    }
   
    public function parseSieveScript( $script )
    {
	$pos = strripos($script, "#PseudoScript#");
	// Esse 17 hardcodificado é temporário rapá! É o tamanho da palavra #PseudoScript## que vem antes do pseudoscript em si.
	$pseudo_script = substr( $script, $pos+17 );

	$return = json_decode( $pseudo_script, true );

	return $return;

// 		if( !$array_rules )
// 		{
// 		    require_once ROOTPATH.'/../expressoMail1_2/inc/class.ScriptS.inc.php';
// 
// 		    $rules = ScriptS::readScript( $script );
// 
// 		    foreach( $rules['rule'] as $i => $rule )
// 		    {
// 			$rule = ScriptS::parsePseudoScript( $rule );
// 
// 			ob_start();
// 			print_r( var_export($rule) );
// 			$output = ob_get_clean();
// 			file_put_contents( '/tmp/2.log', file_get_contents( '/tmp/2.log' ) . $output );
// 		    }
// 	
  }

  var $rules = false;

  public function __construct()
  {
      
  }

  public function getRules()
  {
      $this->rules = Controller::find( array( 'concept' => 'filter' ) );

      if( !$this->rules ) 
	  $this->rules = array();

      return( $this->rules );
  }

  public function applySieveFilter( &$uri , &$result , &$criteria , $original , &$service ){
     
      if( $original['properties']['applyMessages'] )
      {
          $filter = Controller::read($uri);
          
          $proc = array();
          $proc['keep'] = false;
          
          foreach ($filter['actions'] as $v){
              if($v['type'] == 'keep')
                  $proc['keep'] = true;
              else{
                  $proc['type'] = $v['type'];
                  $proc['parameter'] = $v['parameter'];
              }
          }

	  $imap = Controller::service( 'Imap' );
          
          $imap->apliSieveFilter($original['properties']['applyMessages'] , $proc );

          return $result;
      }
  }

  public function readUserScript( &$uri , &$params , &$criteria , $original, &$service )
  {
      $uri['id'] = $service->config['user'];
  }

  public function setRule( &$uri , &$params , &$criteria , $original , &$service )
  {
      if( !$this->rules )
	  $this->rules = $this->getRules();

      $params['id'] = $uri['id'];

      $update = false;

      foreach( $this->rules as $i => $rule )
	  if( $update = ($rule['id'] === $params['id']) )
	  {
	      $this->rules[$i] = $params;
	      break;
	  }

      if( !$update )
	  $this->rules[] = $params;

      $content = $this->formatSieveScript( $this->rules );

      $params = array( 'name' => $service->config['user'],
		       'content' => $content,
                       'active' => true );
  }

  public function deleteRule( &$uri, &$params, &$criteria, $original, &$service )
  {
      if( !$this->rules )
	  $this->rules = $this->getRules();

      $params['id'] = $uri['id'];

      $update = false;

      foreach( $this->rules as $i => $rule )
	  if( $rule['id'] === $uri['id'] )
	      unset( $this->rules[$i] );

      $uri['id'] = '';

      $params = array( 'name' => $service->config['user'],
		       'content' => $this->formatSieveScript( $this->rules ),
		       'active' => true );

      $URI = Controller::URI( $uri['concept'], $service->config['user'] );

      $service->update( $URI, $params );
  }

  public function getSieveRule( &$uri , &$params , &$criteria , $original, &$service )
  {
      $script = $this->parseSieveScript( $params['content'] );

      foreach( $script as $i => $rule )
	  if( $rule['name'] === $original['id'] )
	      return( $params = $rule );
  }

  public function listSieveRules( &$uri , &$params , &$criteria , $original , &$service )
  {
      return( $params = $this->parseSieveScript( $params[0]['content'] ) );
  }
}